mergetool: use more conservative temporary filenames
[git/git.git] / git-sh-setup.sh
CommitLineData
11d62145
JN
1# This shell scriplet is meant to be included by other shell scripts
2# to set up some variables pointing at the normal git directories and
3# a few helper shell functions.
b33e9666 4
365527ad 5# Having this variable in your environment would break scripts because
e598c517 6# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
7# like CDPATH, define it for your interactive shell sessions without
8# exporting it.
785063e0 9# But we protect ourselves from such a user mistake nevertheless.
365527ad
JH
10unset CDPATH
11
393050c3
JH
12# Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
13# do not equate an unset IFS with IFS with the default, so here is
14# an explicit SP HT LF.
15IFS='
16'
785063e0 17
61dbb3c4
JH
18git_broken_path_fix () {
19 case ":$PATH:" in
20 *:$1:*) : ok ;;
21 *)
22 PATH=$(
23 SANE_TOOL_PATH="$1"
24 IFS=: path= sep=
25 set x $PATH
26 shift
27 for elem
28 do
29 case "$SANE_TOOL_PATH:$elem" in
30 (?*:/bin | ?*:/usr/bin)
31 path="$path$sep$SANE_TOOL_PATH"
32 sep=:
33 SANE_TOOL_PATH=
34 esac
35 path="$path$sep$elem"
36 sep=:
37 done
38 echo "$path"
39 )
40 ;;
41 esac
42}
43
44# @@BROKEN_PATH_FIX@@
0e0aea5a 45
adb231cf
FG
46die () {
47 die_with_status 1 "$@"
48}
49
50die_with_status () {
51 status=$1
52 shift
89b0230a 53 printf >&2 '%s\n' "$*"
adb231cf 54 exit "$status"
b33e9666
LT
55}
56
e064c170
SB
57GIT_QUIET=
58
59say () {
60 if test -z "$GIT_QUIET"
61 then
62 printf '%s\n' "$*"
63 fi
64}
65
bac199b7
PH
66if test -n "$OPTIONS_SPEC"; then
67 usage() {
5d292756
JH
68 "$0" -h
69 exit 1
bac199b7
PH
70 }
71
e817e3e8
PH
72 parseopt_extra=
73 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
74 parseopt_extra="--keep-dashdash"
51ba8ce3
NV
75 [ -n "$OPTIONS_STUCKLONG" ] &&
76 parseopt_extra="$parseopt_extra --stuck-long"
e817e3e8
PH
77
78 eval "$(
cbea86fd 79 echo "$OPTIONS_SPEC" |
e817e3e8
PH
80 git rev-parse --parseopt $parseopt_extra -- "$@" ||
81 echo exit $?
82 )"
bac199b7 83else
1b1dd23f 84 dashless=$(basename "$0" | sed -e 's/-/ /')
bac199b7 85 usage() {
0b54366c 86 die "usage: $dashless $USAGE"
bac199b7
PH
87 }
88
89 if [ -z "$LONG_USAGE" ]
90 then
0b54366c 91 LONG_USAGE="usage: $dashless $USAGE"
bac199b7 92 else
0b54366c 93 LONG_USAGE="usage: $dashless $USAGE
bac199b7
PH
94
95$LONG_USAGE"
96 fi
97
98 case "$1" in
87182b17 99 -h)
bac199b7
PH
100 echo "$LONG_USAGE"
101 exit
102 esac
103fi
d025524d 104
c3e2d189
JH
105# Set the name of the end-user facing command in the reflog when the
106# script may update refs. When GIT_REFLOG_ACTION is already set, this
107# will not overwrite it, so that a scripted Porcelain (e.g. "git
108# rebase") can set it to its own name (e.g. "rebase") and then call
109# another scripted Porcelain (e.g. "git am") and a call to this
110# function in the latter will keep the name of the end-user facing
111# program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
112# does will be record as actions done as part of the end-user facing
113# operation (e.g. "rebase").
114#
115# NOTE NOTE NOTE: consequently, after assigning a specific message to
116# GIT_REFLOG_ACTION when calling a "git" command to record a custom
117# reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
118# after you are done. Other callers of "git" commands that rely on
119# writing the default "program name" in reflog expect the variable to
120# contain the value set by this function.
121#
122# To use a custom reflog message, do either one of these three:
123#
124# (a) use a single-shot export form:
125# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
126# git command-that-updates-a-ref
127#
128# (b) save the original away and restore:
129# SAVED_ACTION=$GIT_REFLOG_ACTION
130# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
131# git command-that-updates-a-ref
132# GIT_REFLOG_ACITON=$SAVED_ACTION
133#
134# (c) assign the variable in a subshell:
135# (
136# GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
137# git command-that-updates-a-ref
138# )
f9474132
SP
139set_reflog_action() {
140 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
141 then
142 GIT_REFLOG_ACTION="$*"
143 export GIT_REFLOG_ACTION
144 fi
145}
146
ef0c2abf 147git_editor() {
b4479f07
JN
148 if test -z "${GIT_EDITOR:+set}"
149 then
150 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
151 fi
152
153 eval "$GIT_EDITOR" '"$@"'
ef0c2abf
AR
154}
155
f6dff119
JN
156git_pager() {
157 if test -t 1
158 then
159 GIT_PAGER=$(git var GIT_PAGER)
160 else
161 GIT_PAGER=cat
162 fi
163 : ${LESS=-FRSX}
e54c1f2d
JN
164 : ${LV=-c}
165 export LESS LV
f6dff119
JN
166
167 eval "$GIT_PAGER" '"$@"'
168}
169
e1622bfc
JH
170sane_grep () {
171 GREP_OPTIONS= LC_ALL=C grep "$@"
172}
173
174sane_egrep () {
175 GREP_OPTIONS= LC_ALL=C egrep "$@"
176}
177
4b441f47 178is_bare_repository () {
5be60078 179 git rev-parse --is-bare-repository
4b441f47
JH
180}
181
9fde9401 182cd_to_toplevel () {
91dc602d
SD
183 cdup=$(git rev-parse --show-toplevel) &&
184 cd "$cdup" || {
185 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
186 exit 1
187 }
9fde9401
JH
188}
189
e2eb5273
JH
190require_work_tree_exists () {
191 if test "z$(git rev-parse --is-bare-repository)" != zfalse
192 then
193 die "fatal: $0 cannot be used without a working tree."
194 fi
195}
196
7eff28a9 197require_work_tree () {
ab62677b 198 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
7eff28a9
SP
199 die "fatal: $0 cannot be used without a working tree."
200}
201
92c62a3f
RR
202require_clean_work_tree () {
203 git rev-parse --verify HEAD >/dev/null || exit 1
204 git update-index -q --ignore-submodules --refresh
205 err=0
206
207 if ! git diff-files --quiet --ignore-submodules
208 then
209 echo >&2 "Cannot $1: You have unstaged changes."
210 err=1
211 fi
212
213 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
214 then
215 if [ $err = 0 ]
216 then
217 echo >&2 "Cannot $1: Your index contains uncommitted changes."
218 else
219 echo >&2 "Additionally, your index contains uncommitted changes."
220 fi
221 err=1
222 fi
223
224 if [ $err = 1 ]
225 then
226 test -n "$2" && echo >&2 "$2"
227 exit 1
228 fi
229}
230
ce80ca56
JK
231# Generate a sed script to parse identities from a commit.
232#
233# Reads the commit from stdin, which should be in raw format (e.g., from
234# cat-file or "--pretty=raw").
235#
236# The first argument specifies the ident line to parse (e.g., "author"), and
237# the second specifies the environment variable to put it in (e.g., "AUTHOR"
238# for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
239# committer.
240pick_ident_script () {
241 while test $# -gt 0
242 do
243 lid=$1; shift
244 uid=$1; shift
245 printf '%s' "
246 /^$lid /{
247 s/'/'\\\\''/g
248 h
249 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
250 s/.*/GIT_${uid}_NAME='&'/p
251
252 g
253 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
254 s/.*/GIT_${uid}_EMAIL='&'/p
255
256 g
257 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
258 s/.*/GIT_${uid}_DATE='&'/p
259 }
260 "
261 done
262 echo '/^$/q'
263}
264
265# Create a pick-script as above and feed it to sed. Stdout is suitable for
266# feeding to eval.
267parse_ident_from_commit () {
268 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
269}
270
271# Parse the author from a commit given as an argument. Stdout is suitable for
272# feeding to eval to set the usual GIT_* ident variables.
0cae2346 273get_author_ident_from_commit () {
0cae2346 274 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 275 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
ce80ca56 276 parse_ident_from_commit author AUTHOR
0cae2346
JS
277}
278
7d750f0e
GB
279# Clear repo-local GIT_* environment variables. Useful when switching to
280# another repository (e.g. when entering a submodule). See also the env
281# list in git_connect()
282clear_local_git_env() {
283 unset $(git rev-parse --local-env-vars)
284}
285
4549162e
KB
286# Generate a virtual base file for a two-file merge. Uses git apply to
287# remove lines from $1 that are not in $2, leaving only common lines.
288create_virtual_base() {
289 sz0=$(wc -c <"$1")
290 @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
291 sz1=$(wc -c <"$1")
292
293 # If we do not have enough common material, it is not
294 # worth trying two-file merge using common subsections.
295 expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
296}
297
87bddba9 298
10587ce6 299# Platform specific tweaks to work around some commands
87bddba9
JS
300case $(uname -s) in
301*MINGW*)
302 # Windows has its own (incompatible) sort and find
303 sort () {
304 /usr/bin/sort "$@"
305 }
306 find () {
307 /usr/bin/find "$@"
308 }
be39048a
RJ
309 # git sees Windows-style pwd
310 pwd () {
311 builtin pwd -W
312 }
5e9677cb
PT
313 is_absolute_path () {
314 case "$1" in
315 [/\\]* | [A-Za-z]:*)
316 return 0 ;;
317 esac
318 return 1
319 }
87bddba9 320 ;;
5e9677cb
PT
321*)
322 is_absolute_path () {
323 case "$1" in
324 /*)
325 return 0 ;;
326 esac
327 return 1
328 }
87bddba9 329esac
10587ce6
JH
330
331# Make sure we are in a valid repository of a vintage we understand,
332# if we require to be in a git repository.
333if test -z "$NONGIT_OK"
334then
335 GIT_DIR=$(git rev-parse --git-dir) || exit
336 if [ -z "$SUBDIRECTORY_OK" ]
337 then
338 test -z "$(git rev-parse --show-cdup)" || {
339 exit=$?
340 echo >&2 "You need to run this command from the toplevel of the working tree."
341 exit $exit
342 }
343 fi
344 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
345 echo >&2 "Unable to determine absolute path of git directory"
346 exit 1
347 }
348 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
349fi
bac1ddd0
RR
350
351peel_committish () {
352 case "$1" in
353 :/*)
354 peeltmp=$(git rev-parse --verify "$1") &&
355 git rev-parse --verify "${peeltmp}^0"
356 ;;
357 *)
358 git rev-parse --verify "${1}^0"
359 ;;
360 esac
361}